// mpi02.cpp
// $ mpiCC mpi01.cpp -o mpi01
// $ mpirun -np 4 mpi01

#include "mpi.h"   // Biblioteca de MPI
#include <iostream>

#define N 4

using namespace std;
 
int main(int argc, char *argv[]) 
{ 
    int i, // Numero de iteraciones
		rank, // Identificador de proceso
		size; // Numero de procesos

	int nV[N] = {10,20,30,40};
 
    MPI_Init(&argc, &argv); // Inicializamos los procesos
    MPI_Comm_size(MPI_COMM_WORLD, &size); // Obtenemos el numero total de procesos
    MPI_Comm_rank(MPI_COMM_WORLD, &rank); // Obtenemos el valor de nuestro identificador
 
    // Solo el proceso 0 va a conocer el numero de iteraciones que vamos a
    // ejecutar para la aproximacion de PI
	if (rank == 0) {
		cout << "Hi ha " << size << " processos executant-se." << endl;
		for(i = 0 ; i < N ; i++)
			cout << "Procés 0, iteració " << i << " : " << nV[i] << endl;
	}
	if(size == 4)
		cout << "Sóc el procés " << rank << " : nV[" << rank << "] = " << nV[rank] << endl;
	if(size == 2)
		for(i = 0 ; i < 2 ; i++)
			cout << "Sóc el procés " << rank << " : nV[" << i+rank*2 << "] = " << nV[i+rank*2] << endl;

    MPI_Finalize(); 
    return 0; 
}
