// mpi03.cpp
// $ mpiCC mpi01.cpp -o mpi01
// $ mpirun -np 4 mpi01

#include "mpi.h"   // Biblioteca de MPI
#include <iostream>

#define N 4

using namespace std;

int nSeguentProces(int n){
	n++;
	if(n >= N)
		n = 0;
	return n;
}

int nAnteriorProces(int n){
	n--;
	if(n <= 0)
		n = N-1;
	return n;
}

int main(int argc, char *argv[]) 
{ 
    int i, // Numero de iteraciones
		rank, // Identificador de proceso
		size; // Numero de procesos

	int nV[N] = {10,20,30,40},nR,nLocal,nRebut,j;
	
    MPI_Status estat;
 
    MPI_Init(&argc, &argv); // Inicializamos los procesos
    MPI_Comm_size(MPI_COMM_WORLD, &size); // Obtenemos el numero total de procesos
    MPI_Comm_rank(MPI_COMM_WORLD, &rank); // Obtenemos el valor de nuestro identificador
 
	if(size != 4){
		    MPI_Finalize(); 
			return -1;
	}
	
	for(j = 0 ; j < 1 ; j++){ 
		if (rank == 0) {
			cout << "Hi ha " << size << " processos executant-se." << endl;
			for(i = 0 ; i < N ; i++)
				cout << "Procés 0, iteració " << i << " : " << nV[i] << endl;
		}
		nLocal = nV[rank];

//		if(rank % 2){
			printf("El procés %d tramet nLocal : %d\n",rank,nLocal);
			MPI_Send(&nLocal, 1, MPI_INT, nSeguentProces(rank), 0, MPI_COMM_WORLD);
//		}

		printf(">> Procés %d\n",rank);

//		if(! (rank % 2)){
			MPI_Recv(&nRebut, 1, MPI_INT, nAnteriorProces(rank), 0, MPI_COMM_WORLD,
				   MPI_STATUS_IGNORE);

			printf("El procés %d ha rebut nRebut %d del procés %d\n",rank,nRebut,nAnteriorProces(rank));
//		}
	}

    MPI_Finalize(); 
    return 0; 
}
